#ifndef DB_RESULT_FILE_H
#define DB_RESULT_FILE_H

#include "ResultFile.h"
#include <db.h>

class DBResultFile {
public:
    static DBResultFile* open( const char* filename );
    ~DBResultFile();
    int close();
    int flush();

    /**
     * malloc()s. caller's responsibility.
     */
    Result* get( int choices, int voters, float error );

    int put( Result* it, int choices, int voters, float error );
    
    int useNames( const NameBlock* namesIn );

    DBT systemNames;
    DBT errorSteps;
    DBT choiceSteps;
    DBT voterSteps;
    NameBlock names;
    inline int numSystems() { return names.nnames; }
/*protected:*/
    DBResultFile( void* dbIn );
    DB* db;
};

class ResultKeyStruct {
public:
    int choices;
    int voters;
    float error;
    ResultKeyStruct( int c, int v, float e );
};

#endif
