#ifndef WORK_QUEUE_H
#define WORK_QUEUE_H

#include <pthread.h>

class WorkUnit {
public:
    int numv;
    int numc;
    float error;
    int trials;

    WorkUnit* next;

    WorkUnit( int nv, int nc, float e, int t );
    
    void print( void* file );
};

class WorkSource {
public:
    virtual WorkUnit* newWorkUnit() = 0;
};

class WorkQueue : public WorkSource {
public:
    WorkQueue();
    virtual ~WorkQueue();
    
    void add( WorkUnit* it );
    WorkUnit* pop();
    virtual WorkUnit* newWorkUnit(); // calls pop

protected:
    WorkUnit* head;
    WorkUnit* tail;
};

class ThreadSafeWorkSource {
public://protected:
    pthread_mutex_t m;
    WorkSource* realSource;
public:
    ThreadSafeWorkSource( WorkSource* source );
    virtual ~ThreadSafeWorkSource();
    virtual WorkUnit* newWorkUnit();
};

#endif
