#include "BordaVotingSystem.h"
#include <limits.h>
#include <stdio.h>

BordaVotingSystem::~BordaVotingSystem() {
    if ( talley ) {
	delete [] talley;
    }
}

int BordaVotingSystem::voteRanking( int* ranking ) {
    int i;
    for ( i = 0; i < numc; i++ ) {
	if ( ranking[i] == INT_MAX ) {
	    // unranked, give no points
#if NO_CHECK_VALUES
#else
	} else if ( (ranking[i] < 1) || (ranking[i] > numc) ) {
	    return -1;
#endif
	} else {
	    talley[i] = talley[i] + numc - ranking[i];
	}
//	printf("talley[%d] = %d\n", i, talley[i] );
    }
    return 0;
}

int BordaVotingSystem::getWinners( int* choiceIndecies ) {
    int max = INT_MIN;
    int i;
    int numWinners;
    for ( i = 0; i < numc; i++ ) {
	if ( talley[i] > max ) {
	    choiceIndecies[0] = i;
	    numWinners = 1;
	    max = talley[i];
	} else if ( talley[i] == max ) {
	    choiceIndecies[numWinners] = i;
	    numWinners++;
	}
    }
    return numWinners;
}

int BordaVotingSystem::write( int fd ) {
    return 0;
}

int BordaVotingSystem::read( int fd ) {
    return 0;
}

VotingSystem* BordaVotingSystem::newBordaVotingSystem( int numc ) {
    return new BordaVotingSystem( numc );
}
