package org.bolson.vote;
public class BordaVotingSystem extends RankedVotingSystem {
    protected int talley[];
    public BordaVotingSystem( int numCandidates ) {
	super( numCandidates );
	talley = new int[numc];
	for ( int i = 0; i < numc; i++ ) {
	    talley[i] = 0;
	}
    }

    public int voteRanking( int ranking[] ) {
	int i;
	for ( i = 0; i < numc; i++ ) {
	    if ( ranking[i] == Integer.MAX_VALUE ) {
		// unranked, give no points
    /* CHECK_VALUES */
	    } else if ( (ranking[i] < 1) || (ranking[i] > numc) ) {
		return -1;
	    } else {
		talley[i] = talley[i] + numc - ranking[i];
	    }
	}
	return 0;
    }

    public int[] getWinners() {
	int max = Integer.MIN_VALUE;
	int i;
	int numWinners = 0;
	int choiceIndecies[] = new int[numc];
	for ( i = 0; i < numc; i++ ) {
	    if ( talley[i] > max ) {
		choiceIndecies[0] = i;
		numWinners = 1;
		max = talley[i];
	    } else if ( talley[i] == max ) {
		choiceIndecies[numWinners] = i;
		numWinners++;
	    }
	}
	int winners[] = new int[numWinners];
	for ( i = 0; i < numWinners; i++ ) {
	    winners[i] = choiceIndecies[i];
	}
	return winners;
    }

    public String toString() {
	StringBuffer sb = new StringBuffer("BordaVotingSystem for ");
	sb.append( talley.length );
	sb.append( " choices:");
	for ( int i = 0; i < talley.length; i++ ) {
	    sb.append('\t').append( talley[i] );
	}
	return sb.toString();
    }
};
