package org.bolson.vote;
public class RawRating extends RatedVotingSystem {
    public RawRating( int numCandidates ) {
    	super( numCandidates );
	talley = new long[numc];
	for ( int i = 0; i < numc; i++ ) {
	    talley[i] = 0;
	}
    }

    public int voteRating( int rating[] )  {
	int i;
	for ( i = 0; i < numc; i++ ) {
	    talley[i] += rating[i];
	}
	return 0;
    }

    public int[] getWinners() {
	long max = Long.MIN_VALUE;
	int i;
	int numWinners = 0;
	int choiceIndecies[] = new int[numc];
	for ( i = 0; i < numc; i++ ) {
	    if ( talley[i] > max ) {
		choiceIndecies[0] = i;
		numWinners = 1;
		max = talley[i];
	    } else if ( talley[i] == max ) {
		choiceIndecies[numWinners] = i;
		numWinners++;
	    }
	}
	int winners[] = new int[numWinners];
	for ( i = 0; i < numWinners; i++ ) {
	    winners[i] = choiceIndecies[i];
	}
	return winners;
    }

    
    void squashToAcceptance( int rating[] ) {
	for ( int i = 0; i < numc; i++ ) {
	    if ( rating[i] >= 0 ) {
		rating[i] = 1;
	    } else {
		rating[i] = 0;
	    }
	}
    }
    
    protected long talley[];
    
    public String toString() {
	StringBuffer sb = new StringBuffer("RawRating for ");
	sb.append( talley.length );
	sb.append( " choices:");
	for ( int i = 0; i < talley.length; i++ ) {
	    sb.append('\t').append( talley[i] );
	}
	return sb.toString();
    }
};
