#!/usr/bin/perl -w
#use Steps;
#chdir "graph" or die "no graph/";
$outputPrefixP = "graph/";

$imgsize = "width=\"960\" height=\"720\"";

@vs = <v*>;
print "vs @vs\n";
@vsteps = ();
foreach $vv ( @vs ) {
    ($v) = $vv =~ /v([[:digit:]]*)/;
    if ( $v ) {
	@vsteps = ( @vsteps, $v );
    }
}
print "vsteps @vsteps\n";

VLOOP: foreach $vi ( @vsteps ) {
    $outputPrefix = $outputPrefixP . "v" . $vi;
    @f = <$outputPrefix/c*.png>;
    %ch = ();
    foreach $ff ( @f ) {
	( $c ) = $ff =~ /c(.*).png/;
	if ( $c ) {
	    $ch{$c} = 1;
	}
    }
    @csteps = sort( keys %ch );
    if ( ! @csteps ) {
	print "no csteps\n";
	last VLOOP;
    }
    @f = <$outputPrefix/e*.png>; 
    %eh = ();
    foreach $ff ( @f ) {
	( $e ) = $ff =~ /e(.*).png/;
	if ( $e ) {
	    $eh{$e} = 1;
	}
    }
    @esteps = sort( keys %eh );
    if ( ! @esteps ) {
	print "no esteps\n";
	last VLOOP;
    }
    print "csteps \"@csteps\"\n";
    print "esteps \"@esteps\"\n";

    open FS, ">$outputPrefix/index.html";
    print FS "<html><head><title>Graphs With $vi Voters</title></head><body bgcolor=\"#ffffff\"><h1>Graphs With $vi Voters</h1>\n";
    foreach $ei ( @esteps ) {
	print FS "<hr><img src=\"e$ei.png\" $imgsize>\n";
    }
    foreach $ci ( @csteps ) {
	printf FS "<hr><img src=\"c%02d.png\" $imgsize>\n", $ci;
    }
    print FS "</body></html>\n";
    close FS;
}

$outputPrefix = $outputPrefixP . "v";
@they = <$outputPrefix*/c*.png>;
%ch = ();
foreach $ff ( @they ) {
    ( $c ) = $ff =~ /c(.*).png/;
    if ( $c ) {
	$ch{$c} = 1;
    }
}
@csteps = sort( keys %ch );
$outputPrefix = $outputPrefixP . "c";
foreach $ci ( @csteps ) {
    $cs = sprintf "%02d", $ci;
    open FOUT, ">$outputPrefix$cs.html";
    print FOUT "<html><head><title>Graphs With $ci Choices</title></head><body bgcolor=\"#ffffff\"><h1>Graphs With $ci Choices</h1>\n";
    foreach $vi ( @vsteps ) {
	$file = $outputPrefixP . "v$vi/c$ci.png";
	if ( -r $file ) {
	    print FOUT "<hr><img src=\"v$vi/c$ci.png\" $imgsize>\n";
	}
    }
    print FOUT "</body></html>\n";
    close FOUT;
}
$outputPrefix = $outputPrefixP . "v";
@f = <$outputPrefix*/e*.png>; 
%eh = ();
foreach $ff ( @f ) {
    ( $e ) = $ff =~ /e(.*).png/;
    if ( $e ) {
	$eh{$e} = 1;
    }
}
@esteps = sort( keys %eh );
$outputPrefix = $outputPrefixP . "e";
foreach $ei ( @esteps ) {
    open FOUT, ">$outputPrefix$ei.html";
    print FOUT "<html><head><title>Graphs With $ei Error</title></head><body bgcolor=\"#ffffff\"><h1>Graphs With $ei Error</h1>\n";
    @they = <*/e$ei.png>;
    foreach $vi ( @vsteps ) {
	$file = $outputPrefixP . "v$vi/e$ei.png";
	if ( -r $file ) {
	    print FOUT "<hr><img src=\"v$vi/e$ei.png\" $imgsize>\n";
	}
    }
    print FOUT "</body></html>\n";
    close FOUT;
}

$file = $outputPrefixP . "index.html";
open FOUT, ">$file";
print FOUT "<html><head><title>Graphs</title></head><body bgcolor=\"#ffffff\">\n";
print FOUT "<h1>Graphs By Voters</h1>\n";
foreach $vi ( @vsteps ) {
    $file = $outputPrefixP . "v$vi/index.html";
    if ( -r $file ) {
	print FOUT "<a href=\"v$vi/index.html\">$vi Voters</a>( choices or error vary )<br>\n";
    }
}
print FOUT "<h1>Graphs By Error</h1>\n";
foreach $ei ( @esteps ) {
    $file = $outputPrefixP . "e$ei.html";
    if ( -r $file ) {
	print FOUT "<a href=\"e$ei.html\">$ei Error</a>( choices or voters vary )<br>\n";
    }
}
print FOUT "<h1>Graphs By Choices</h1>\n";
foreach $ci ( @csteps ) {
    $cs = sprintf "%02d", $ci;
    $file = $outputPrefixP . "c$cs.html";
    if ( -r $file ) {
	print FOUT "<a href=\"c$cs.html\">$ci Choices</a>( error or voters vary )<br>\n";
    }
}
print FOUT "</body></html>\n";
close FOUT;

